<?php
/*---------------------------------------------------------------*/
/*
    Titre : Création massive de fichiers zip                                                                             
                                                                                                                          
    URL   : https://phpsources.net/code_s.php?id=338
    Date dition     : 05 Fv 2008                                                                                        
    Date mise  jour : 18 Sept 2019
                                                                                      
    Rapport de la maj:                                                                                                    
    - fonctionnement du code vérifié                                                                                    
    - amélioration du code                                                                                               
*/
/*---------------------------------------------------------------*/


/*******************************************************************************
 
    * connection sql 
    ***************************************************************************/
 
    $db_server = 'localhost'; // Adresse du serveur MySQL
    $db_name = '';            // Nom de la base de données
    $db_user_login = 'root';  // Nom de l'utilisateur
    $db_user_pass = '';       // Mot de passe de l'utilisateur

    // Ouvre une connexion au serveur MySQL
    $conn = mysqli_connect($db_server,$db_user_login, $db_user_pass, $db_name);

    $table_sql = "";  // nom de votre table

/*******************************************************************************
 
    * lib
    ***************************************************************************/
 

 
   /**
    * Zip file creation class.
    * Makes zip files.
    *
    * Based on :
    *
    *  http://www.zend.com/codex.php?id=535&single=1
    *  By Eric Mueller <eric@themepark.com>
    *
    *  http://www.zend.com/codex.php?id=470&single=1
    *  by Denis125 <webmaster@atlant.ru>
    *

    *  a patch from Peter Listiak <mlady@users.sourceforge.net> for last modified
    *  date and time of the compressed file
    *
    * Official ZIP file format: http://www.pkware.com/appnote.txt
    *
    * @access  public
    */
   class zipfile
   {
    /**
     * Array to store compressed data
     *
     * @var  array    $datasec
     */
    var $datasec      = array();

    /**
     * Central directory
     *
     * @var  array    $ctrl_dir
     */
    var $ctrl_dir     = array();

    /**
     * End of central directory record
     *
     * @var  string   $eof_ctrl_dir
     */
    var $eof_ctrl_dir = "\x50\x4b\x05\x06\x00\x00\x00\x00";

    /**
     * Last offset position
     *
     * @var  integer  $old_offset
     */
    var $old_offset   = 0;


    /**
     * Converts an Unix timestamp to a four byte DOS date and time format (date
     * in high two bytes, time in low two bytes allowing magnitude comparison).
     *
     * @param  integer  the current Unix timestamp
     *
     * @return integer  the current date in a four byte DOS format
     *
     * @access private
     */
    function unix2DosTime($unixtime = 0) {
        $timearray = ($unixtime == 0) ? getdate() : getdate($unixtime);

        if ($timearray['year'] < 1980) {
            $timearray['year']    = 1980;
            $timearray['mon']     = 1;
            $timearray['mday']    = 1;
            $timearray['hours']   = 0;
            $timearray['minutes'] = 0;
            $timearray['seconds'] = 0;
        } // end if

        return (($timearray['year'] - 1980) << 25) | ($timearray['mon'] << 21) |
 ($timearray['mday'] << 16) |
                ($timearray['hours'] << 11) | ($timearray['minutes'] << 5) | (
$timearray['seconds'] >> 1);
    } // end of the 'unix2DosTime()' method


    /**
     * Adds "file" to archive
     *
     * @param  string   file contents
     * @param  string   name of the file in the archive (may contains the path)
     * @param  integer  the current timestamp
     *
     * @access public
     */
    function addFile($data, $name, $time = 0)
    {
        $name     = str_replace('\\', '/', $name);

        $dtime    = dechex($this->unix2DosTime($time));
        $hexdtime = '\x' . $dtime[6] . $dtime[7]
                  . '\x' . $dtime[4] . $dtime[5]
                  . '\x' . $dtime[2] . $dtime[3]
                  . '\x' . $dtime[0] . $dtime[1];
        eval('$hexdtime = "' . $hexdtime . '";');

        $fr   = "\x50\x4b\x03\x04";
        $fr   .= "\x14\x00";            // ver needed to extract
        $fr   .= "\x00\x00";            // gen purpose bit flag
        $fr   .= "\x08\x00";            // compression method
        $fr   .= $hexdtime;             // last mod time and date

        // "local file header" segment
        $unc_len = strlen($data);
        $crc     = crc32($data);
        $zdata   = gzcompress($data);
        $zdata   = substr(substr($zdata, 0, strlen($zdata) - 4), 2); 
// fix crc bug
        $c_len   = strlen($zdata);
        $fr      .= pack('V', $crc);             // crc32
        $fr      .= pack('V', $c_len);           // compressed filesize
        $fr      .= pack('V', $unc_len);         // uncompressed filesize
        $fr      .= pack('v', strlen($name));    // length of filename
        $fr      .= pack('v', 0);                // extra field length
        $fr      .= $name;

        // "file data" segment
        $fr .= $zdata;

        // "data descriptor" segment (optional but necessary if archive is not
        // served as file)
        // nijel(2004-10-19): this seems not to be needed at all and causes
        // problems in some cases (bug #1037737)
        //$fr .= pack('V', $crc);                 // crc32
        //$fr .= pack('V', $c_len);               // compressed filesize
        //$fr .= pack('V', $unc_len);             // uncompressed filesize

        // add this entry to array
        $this -> datasec[] = $fr;

        // now add to central directory record
        $cdrec = "\x50\x4b\x01\x02";
        $cdrec .= "\x00\x00";                // version made by
        $cdrec .= "\x14\x00";                // version needed to extract
        $cdrec .= "\x00\x00";                // gen purpose bit flag
        $cdrec .= "\x08\x00";                // compression method
        $cdrec .= $hexdtime;                 // last mod time & date
        $cdrec .= pack('V', $crc);           // crc32
        $cdrec .= pack('V', $c_len);         // compressed filesize
        $cdrec .= pack('V', $unc_len);       // uncompressed filesize
        $cdrec .= pack('v', strlen($name) ); // length of filename
        $cdrec .= pack('v', 0 );             // extra field length
        $cdrec .= pack('v', 0 );             // file comment length
        $cdrec .= pack('v', 0 );             // disk number start
        $cdrec .= pack('v', 0 );             // internal file attributes
        $cdrec .= pack('V', 32 );            
// external file attributes - 'archive' bit set

        $cdrec .= pack('V', $this -> old_offset ); 
// relative offset of local header
        $this -> old_offset += strlen($fr);

        $cdrec .= $name;

        // optional extra field, file comment goes here
        // save to central directory
        $this -> ctrl_dir[] = $cdrec;
    } // end of the 'addFile()' method


    /**
     * Dumps out file
     *
     * @return  string  the zipped file
     *
     * @access public
     */
    function file()
    {
        $data    = implode('', $this -> datasec);
        $ctrldir = implode('', $this -> ctrl_dir);

        return
            $data .
            $ctrldir .
            $this -> eof_ctrl_dir .
            pack('v', sizeof($this -> ctrl_dir)) .  
// total # of entries "on this disk"
            pack('v', sizeof($this -> ctrl_dir)) .  
// total # of entries overall
            pack('V', strlen($ctrldir)) .           // size of central dir
            pack('V', strlen($data)) .              
// offset to start of central dir
            "\x00\x00";                             // .zip file comment length
    } // end of the 'file()' method

   } // end of the 'zipfile' class
 

/*******************************************************************************
 
    *  Requête + création du zip
    ***************************************************************************/

    $result = $conn->query("SELECT * FROM $table_sql");
    while ($row = mysqli_fetch_array ($result)) {

    $texte = $row['texte'];
    $idx = $row['id'];

/*******************************************************************************
 
    *  Nom des fichiers
    ***************************************************************************/

    //  nom du fichier temporaire

    $nom_file = "code$idx";
    $nom_file .= ".php";

    // c'est ici que vous construisez votre fichier !
    // ex ! archive-12-code.zip
     
    $nom_zip = "archive-$idx";
    $nom_zip .= "-code.zip";
    

    $f = fopen($nom_file, "x+");
    fputs($f, $texte );
    fclose($f);

    $zip = new zipfile() ; //on crée un fichier zip
    $fp = fopen($nom_file,'r') ; //on ouvre le fichier en lecture seule
    $contenu = fread($fp, filesize($nom_file)) ; //on enregistre le contenu
    fclose($fp) ; //on ferme FTP

    $zip->addfile($contenu, $nom_file) ; //on ajoute le fichier

    $archive = $zip->file() ; //on associe l'archive

    header('Content-Type: application/x-zip') ; //on détermine les en-tête
    header('Content-Disposition: inline; filename='.$nom_zip.'') ;

/*******************************************************************************
    *  Copie du fichier zip sur le serveur
    ***************************************************************************/
    $open = fopen($nom_zip, "wb");
    fwrite($open, $archive);
    fclose($open);

    unlink($nom_file);  // destruction du fichier temporaire

/*******************************************************************************
    *  Fin
    ***************************************************************************/

   }
?>